﻿var
selectedFolder,selectedFile:string;
scroll: TScrollBox;
move : Boolean = False;

procedure frmMain_img_OnClick (Sender: TObject);
begin
  frmIMGView.img.Picture.LoadFromFile( frmMain.img.TagString );
  frmIMGView.ShowModal;
end;

procedure frmMain_OnShow (Sender: TObject; Action: string);
begin
  frmMain.OnMouseWheel := @OnMouseWheel;
end;

// автопрокрутка колесиком мышки
procedure OnMouseWheel(Sender: TObject; isShift, isAlt, isCtrl: boolean; WheelDelta: Integer; X, Y: Integer; var Handled: Boolean);
begin
   if (move) then
     if WheelDelta > 0 then scroll.VertScrollBar.Position := scroll.VertScrollBar.Position - 6  else scroll.VertScrollBar.Position := scroll.VertScrollBar.Position + 6;
end;


procedure frmMain_bOpenFolder_OnClick (Sender: TObject; var Cancel: boolean);
begin
  OpenFile(frmMain.bOpenFolder.TagString, 'explorer.exe');
end;

procedure frmMain_bOpenFile_OnClick (Sender: TObject; var Cancel: boolean);
begin
  OpenFile(frmMain.bOpenFile.TagString);
end;

procedure frmMain_bFontMinus_OnClick (Sender: TObject; var Cancel: boolean);
begin
  frmMain.mText.Font.Size := frmMain.mText.Font.Size-1;
end;

procedure frmMain_bFontPlus_OnClick (Sender: TObject; var Cancel: boolean);
begin
  frmMain.mText.Font.Size := frmMain.mText.Font.Size+1;
end;
// загрузка данных выбранного софта
procedure frmMain_tgSoftList_OnCellClick (Sender: TObject; ACol, ARow: Integer);
var
i,n:integer;
list:TStringList;
dbimg: TdbImage;
begin
  // создание листа с id изображений
  list:=TStringList.Create;
  list.Text:=SQLexecute('SELECT group_concat(id, char(13) || char(10)) FROM img WHERE id_soft='+ frmMain.tgSoftList.sqlValue);

  // если в листе есть списки id изображений
  if (list.Count>0) then
  begin
    // если уже еть скролл - уничтожить и создать новый экземпляр
    if (scroll<>Nil) then scroll.Free;
    scroll := TScrollBox.Create(frmMain);
    scroll.Parent := frmMain.pIMG;
    scroll.HorzScrollBar.Visible := False;
    scroll.BevelWidth := 0;
    scroll.BorderStyle := bsNone;
    scroll.Left := 0;
    scroll.Top := 0;
    scroll.Height := frmMain.pIMG.Height;
    scroll.Width := frmMain.pIMG.Width;
    scroll.Visible := True;
    scroll.VertScrollBar.Tracking := True;
    n:=0;
    // добавить в скролл изображения
    for i:=0 to list.Count-1 do
    begin
      dbimg := TdbImage.Create(frmMain);
      dbimg.Parent := scroll;
      dbimg.Tag := i;
      dbimg.Name := 'imgsc'+IntToStr(i);
      dbimg.proportional := True;
      dbimg.Height := 100;
      dbimg.Width := 115;
      dbimg.Left := 5;
      dbimg.Top := i *100;
      dbimg.Visible := True;
      // если изображение найдено
      if (FileExists(SQLExecute('SELECT image FROM img WHERE id='+list[i]))) then
      begin
        dbimg.Picture.LoadFromFile(SQLExecute('SELECT image FROM img WHERE id='+list[i]));
        dbimg.TagString := SQLExecute('SELECT image FROM img WHERE id='+list[i]);
      end else
      // если изображение не найдено
      begin
        dbimg.Picture.LoadFromFile(ExtractFilePath(Application.ExeName)+'\img\no_photo.jpg');
        dbimg.TagString := ExtractFilePath(Application.ExeName)+'\img\no_photo.jpg';
      end;
      // клик по изображению
      dbimg.OnClick := @clickImage;
      // обновить скролл
      scroll.VertScrollBar.Range := dbimg.Top + 120;
      // наведение курсора
      dbimg.OnMouseEnter := @MauseEnter;
      // вывод курсора
      dbimg.OnMouseLeave := @MauseLeave;
      //n:=dbimg.Top+120;
    end;
    // загрузить как основное первое изобраение из списка скролла
    frmMain.img.Picture.LoadFromFile(TdbImage(frmMain.FindComponent('imgsc0')).TagString);
    frmMain.img.TagString := TdbImage(frmMain.FindComponent('imgsc0')).TagString;
  // если езображений нет
  end else  frmMain.img.Picture.LoadFromFile(ExtractFilePath(Application.ExeName)+'\img\no_photo.jpg');
  // иные загрузки данных софта
  frmMain.lNameApp.Caption := SQLexecute('SELECT name FROM soft WHERE id='+frmMain.tgSoftList.sqlValue);
  frmMain.lVersionApp.Caption := SQLexecute('SELECT version FROM soft WHERE id='+frmMain.tgSoftList.sqlValue);
  frmMain.mText.Text := SQLexecute('SELECT desc FROM soft WHERE id='+frmMain.tgSoftList.sqlValue);
  frmMain.bOpenFile.TagString := SQLexecute('SELECT file FROM soft WHERE id='+frmMain.tgSoftList.sqlValue);
  frmMain.bOpenFolder.TagString := SQLexecute('SELECT folder FROM soft WHERE id='+frmMain.tgSoftList.sqlValue);

  frmMain.pLogo.Visible := False;
  frmMain.bDelete.SetFocus;
end;

procedure MauseEnter;
begin
  move := True;
end;

procedure MauseLeave;
begin
  move := False;
end;

procedure clickImage(Sender:TObject);
begin
  frmMain.img.Picture.LoadFromFile(TdbImage(Sender).TagString);
  frmMain.img.TagString := TdbImage(Sender).TagString;
end;

procedure frmAddEdit_tgIMG_OnCellClick (Sender: TObject; ACol, ARow: Integer);
begin
  if (FileExists(frmAddEdit.tgIMG.Cells[0,frmAddEdit.tgIMG.SelectedRow])) then
    frmIMGView.img.Picture.LoadFromFile(frmAddEdit.tgIMG.Cells[0, frmAddEdit.tgIMG.SelectedRow ]) else
    frmIMGView.img.Picture.LoadFromFile(ExtractFilePath(Application.ExeName)+'\img\no_photo.jpg');
  frmIMGView.ShowModal;
end;

procedure frmAddEdit_bDeleteAuto_OnClick (Sender: TObject; var Cancel: boolean);
begin
  if IDYES = MessageBox('Удалить запись?','Удаление',MB_YESNO) then
  begin
    DeleteFile(SQLExecute('SELECT image FROM img WHERE id='+ frmAddEdit.tgIMG.sqlValue));
    SQLExecute('DELETE FROM img WHERE id='+ frmAddEdit.tgIMG.sqlValue);
    UPDATEDATABASE('img');
  end;
end;

procedure frmAddEdit_OnClose (Sender: TObject; Action: string);
begin
  frmAddEdit.bDeleteAuto.Visible := False;
  frmAddEdit.bSaveAuto.Visible := False;
end;

procedure frmMain_bEdit_OnClick (Sender: TObject; var Cancel: boolean);
begin
  frmAddEdit.bDeleteAuto.Visible := True;
  frmAddEdit.bSaveAuto.Visible := True;
end;

procedure frmAddEdit_OnShow (Sender: TObject; Action: string);
begin
  if (Action = 'ShowRecord') then
  begin
    frmAddEdit.bFile.TagString := SQLExecute('SELECT file FROM soft WHERE id=' +frmMain.tgSoftList.sqlValue);
    frmAddEdit.bFolder.TagString := SQLExecute('SELECT folder FROM soft WHERE id=' +frmMain.tgSoftList.sqlValue);
    frmAddEdit.pSelectedFile.Color := $0066A016;
    frmAddEdit.pSelectedFolder.Color := $0066A016;
  end;
end;

procedure frmAddEdit_bSave_OnClick (Sender: TObject; var Cancel: boolean);
var
finishFile,finishFolder,imgFile:string;
i,idLast:integer;
begin
  if (frmAddEdit.eName.Text='') then ShowHint(frmAddEdit.eName,'Поле обязательно к заполнению') else
  if (frmAddEdit.eVersion.Text='') then ShowHint(frmAddEdit.eVersion,'Поле обязательно к заполнению') else
  if (frmAddEdit.cbCategory.ItemIndex=-1) then ShowHint(frmAddEdit.cbCategory,'Поле обязательно к заполнению') else
  if (selectedFile='') then ShowHint(frmAddEdit.bFile,'Вы не указали исполняемы файл') else
  if (frmAddEdit.reDescript.Text='') then ShowHint(frmAddEdit.reDescript,'Поле обязательно к заполнению') else
  begin

  // создание каталогов ***************************************************************
  if not DirectoryExists(ExtractFilePath(Application.ExeName)+'\soft') then
   if not CreateDir(ExtractFilePath(Application.ExeName)+'\soft') then
     Showmessage('Ошибка создания каталога: '+ExtractFilePath(Application.ExeName)+'\soft');
  if not ForceDirectories(ExtractFilePath(Application.ExeName)+'\soft\'+frmAddEdit.cbCategory.Caption+
  '\'+frmAddEdit.eName.Text+'_v_'+frmAddEdit.eVersion.Text+'\img') then Showmessage('Ошибка создания каталога');
 //************************************************************************************

 // проверка места нахождения выбранной папки
 if (Pos(ExtractFilePath(Application.ExeName),selectedFolder)) then
 begin
   // если папка в корне программы
   finishFolder := selectedFolder ;
   if not ForceDirectories(ExtractFilePath(finishFile)+'\img\') then Showmessage('Ошибка создания каталога');
 end else
 begin
  // иначе если папка не в корне папки
  finishFolder := ExtractFilePath(finishFile);
  if (selectedFolder<>'') then DirectoryCopy(selectedFolder,ExtractFilePath(Application.ExeName)+'soft\'+
      frmAddEdit.cbCategory.Caption+'\'+frmAddEdit.eName.Text+'_v_'+frmAddEdit.eVersion.Text+'\');
 end;

 // проверка местонахождения выбранного файла
 if (Pos(ExtractFilePath(Application.ExeName),selectedFile)) then
 begin
   // если файл в корне программы
   finishFile := selectedFile ;
   // добавить папку img
   if not ForceDirectories(ExtractFilePath(finishFile)+'\img\') then Showmessage('Ошибка создания каталога');
   imgFile := ExtractFilePath(finishFile)+'\img\';
 end else
 begin
   // иначе если файл не в корне папки
   finishFile := ExtractFilePath(Application.ExeName)+'soft\'+frmAddEdit.cbCategory.Caption+'\'+
     frmAddEdit.eName.Text+'_v_'+frmAddEdit.eVersion.Text+'\'+ExtractFileName(selectedFile);
   imgFile := ExtractFilePath(Application.ExeName)+'soft\'+frmAddEdit.cbCategory.Caption+'\'+
     frmAddEdit.eName.Text+'_v_'+frmAddEdit.eVersion.Text+'\img\';
   CopyFile(selectedFile,finishFile,True);
 end;

 if (selectedFolder='') then finishFolder := ExtractFilePath(finishFile);

 // создание записи в таблице soft
 SQLExecute('INSERT INTO soft(name,version,file,folder,desc,id_category)VALUES("'+frmAddEdit.eName.Text+'"'+
   ',"'+frmAddEdit.eVersion.Text+'","'+finishFile+'","'+finishFolder+'","'+ frmAddEdit.reDescript.Text +'",'+
   '"'+frmAddEdit.cbCategory.sqlValue+'")');

 idLast := Last_Insert_id;

 // сохранение записи и копирование изображений
 for i := 0 to frmAddEdit.tgIMG.RowCount-1 do
 begin
   // создание пути копирования изображения
   imgFile := imgFile+ExtractFileName(frmAddEdit.tgIMG.Cells[0,i]);
   CopyFile(frmAddEdit.tgIMG.Cells[0,i],imgFile,True);
   SQLExecute('INSERT INTO img(image,id_soft)VALUES("'+imgFile+'","'+IntToStr(idLast)+'")');
 end;
   frmAddEdit.Close;
   selectedFolder := '';
   selectedFile := '';
 end;
end;

procedure frmAddEdit_bDeleteIMG_OnClick (Sender: TObject; var Cancel: boolean);
begin
  if ( frmAddEdit.tgIMG.RowCount>0 )then frmAddEdit.tgIMG.DeleteRow( frmAddEdit.tgIMG.SelectedRow );
end;

procedure frmAddEdit_bAddIMG_OnClick (Sender: TObject; var Cancel: boolean);
var
openDialog:TOpenDialog; // диалог открытия файла
row,i:integer;
imgFile,idimg: string;
begin
  openDialog := TOpenDialog.Create(frmAddEdit);  // Создание объекта OpenDialog
  openDialog.Options := ofHideReadOnly+ofEnableSizing+ofEnableSizing+ofHideReadOnly+ofNoNetworkButton+ofAllowMultiSelect; // Опции диологового окна
  openDialog.InitialDir := ExtractFilePath(Application.ExeName); // Каталог по умолчанию
  openDialog.Filter := 'PNG|*.png|JPG|*.jpg|BMP|*.bmp';  // фильтр разрешенных форматов файлов
  openDialog.FilterIndex := 1;  //Выбор формата файла как стартовый тип фильтра
  if openDialog.Execute then
  begin
    row := frmAddEdit.tgIMG.RowCount;
    frmAddEdit.tgIMG.AddRow(OpenDialog.Files.count);
    // действие с выбранным файлом
    for i := 0 to OpenDialog.Files.count-1 do begin
      frmAddEdit.tgIMG.Cells[0,row] := OpenDialog.Files[i];
      row := row+1;

      if (frmAddEdit.bDeleteAuto.Visible = True) then
      begin
        idimg := SQLexecute('SELECT name FROM category WHERE id='+frmAddEdit.cbCategory.sqlValue);
        imgFile := ExtractFilePath(Application.ExeName)+'soft\'+idimg+'\'+frmAddEdit.eName.Text+
        '\img\'+ExtractFileName(OpenDialog.Files[i]);
        CopyFile(OpenDialog.Files[i],imgFile,True);
        SQLExecute('INSERT INTO img(image,id_soft)VALUES("'+imgFile+'","'+IntToStr(SQLExecute('SELECT id FROM '+
        'soft WHERE id='+ frmMain.tgSoftList.sqlValue))+'")');
        UPDATEDATABASE('img');
        frmAddEdit.tgIMG.dbUpdate;
      end;
    end;
    UPDATEDATABASE('soft');
  end;
  openDialog.Free;
end;

procedure frmAddEdit_bFolder_OnClick (Sender: TObject; var Cancel: boolean);
var
  chosenDirectory : string;
begin
  if ( frmAddEdit.dbAction = 'ShowRecord') then MessageBox('Выбор папки в режиме редактирования не возможен!','Выбор папки', MB_OK) else
  begin
    // Просим пользователя выбрать требуемый каталог, стартовый каталог C:
    if SelectDirectory('Выберите каталог', '' ,chosenDirectory)
    then begin
    selectedFolder := chosenDirectory;
    frmAddEdit.pSelectedFolder.Color := $0066A016;
    frmAddEditbFileOnClick(frmAddEdit.bFile,True,True);  
    end;
  end;
end;

procedure frmAddEditbFileOnClick (Sender: TObject; var Cancel: boolean; Folder:Boolean);
var
openDialog:TOpenDialog; // диалог открытия файла
begin
  if ( frmAddEdit.dbAction = 'ShowRecord') then
  begin
    if IDYES = MessageBox('Вы действительно хотите изменить исполняемый файл?','Выбор файла', MB_YESNO) then
    begin
      openDialog := TOpenDialog.Create(frmAddEdit);  // Создание объекта OpenDialog
      openDialog.Options := ofHideReadOnly+ofEnableSizing+ofEnableSizing+ofHideReadOnly+ofNoNetworkButton ; // Опции диологового окна
      if(Folder) then openDialog.InitialDir := selectedFolder else openDialog.InitialDir := ExtractFilePath( frmAddEdit.bFile.TagString ); // Каталог по умолчанию
      openDialog.Filter := 'EXE|*.exe|MSI|*.msi|ISO|*.iso';  // фильтр разрешенных форматов файлов
      if openDialog.Execute then
      begin
        // действие с выбранным файлом
        SQLExecute('UPDATE soft SET file="'+ openDialog.fileName +'" WHERE id='+ frmMain.tgSoftList.sqlValue );
        UPDATEDATABASE('soft');
      end;
    end else break;
  end else begin
    openDialog := TOpenDialog.Create(frmAddEdit);  // Создание объекта OpenDialog
    openDialog.Options := ofHideReadOnly+ofEnableSizing+ofEnableSizing+ofHideReadOnly+ofNoNetworkButton ; // Опции диологового окна
    if(Folder) then openDialog.InitialDir := selectedFolder else openDialog.InitialDir := ExtractFilePath(Application.ExeName); // Каталог по умолчанию
    openDialog.Filter := 'EXE|*.exe|MSI|*.msi|ISO|*.iso';  // фильтр разрешенных форматов файлов
    if openDialog.Execute then
    begin
      // действие с выбранным файлом
      selectedFile := openDialog.fileName;
      frmAddEdit.pSelectedFile.Color := $0066A016;
    end;
  end;
  Folder:=False;
  openDialog.Free;
end;


begin
end.
